<?php
/*
$Id$

osCommerce, Open Source E-Commerce Solutions
http://www.oscommerce.com

Copyright (c) 2010 osCommerce

Released under the GNU General Public License
*/

class bm_shopping_cart {
	var $code = 'bm_shopping_cart';
	var $group = 'boxes';
	var $title;
	var $description;
	var $sort_order;
	var $enabled = false;

	function bm_shopping_cart() {
		$this->title = MODULE_BOXES_SHOPPING_CART_TITLE;
		$this->description = MODULE_BOXES_SHOPPING_CART_DESCRIPTION;

		if ( defined('MODULE_BOXES_SHOPPING_CART_STATUS') ) {
			$this->sort_order = MODULE_BOXES_SHOPPING_CART_SORT_ORDER;
			$this->enabled = (MODULE_BOXES_SHOPPING_CART_STATUS == 'True');

			$this->group = ((MODULE_BOXES_SHOPPING_CART_CONTENT_PLACEMENT == 'Left Column') ? 'boxes_column_left' : 'boxes_column_right');
		}
	}

	function execute() {
		global $cart, $new_products_id_in_cart, $currencies,  $currency, $oscTemplate, $PHP_SELF;

		$currency_type = (empty($currency)) ? '' : $currency;

		$symbol_left = (empty($currencies->currencies[$currency_type]['symbol_left'])) ? '' : $currencies->currencies[$currency_type]['symbol_left'];

		$symbol_right = (empty($currencies->currencies[$currency_type]['symbol_right'])) ? '' : $currencies->currencies[$currency_type]['symbol_right'];

		$decimal_places = (empty($currencies->currencies[$currency_type]['decimal_places'])) ? '' : $currencies->currencies[$currency_type]['decimal_places'];

		$thousands_point = (empty($currencies->currencies[$currency_type]['thousands_point'])) ? '' : $currencies->currencies[$currency_type]['thousands_point'];

		$decimal_point = (empty($currencies->currencies[$currency_type]['decimal_point'])) ? '' : $currencies->currencies[$currency_type]['decimal_point'];

		$cart_contents_string = '';

		$cart_contents_string = tep_draw_form('boxcart_quantity',
		tep_href_link(FILENAME_SHOPPING_CART, 'action=update_product'));

		if ($cart->count_contents() > 0) {

			$cart_contents_string .= '<ul class="infoBoxContents" id="boxcart-content">';

			$cart_contents_string .= '';

			$products = $cart->get_products();
			for ($i=0, $n=sizeof($products); $i<$n; $i++) {

				$cart_contents_string .= '<li data-id="'.(int)$products[$i]['id'].'" id="pc-' . $products[$i]['id'] . '">';

				if ((tep_session_is_registered('new_products_id_in_cart')) && ($new_products_id_in_cart == $products[$i]['id'])) {
					$cart_contents_string .= '<span class="newItemInCart">';
				}

				$cart_contents_string .= '<span class="name"><a class="JSlink" href="' .
					tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $products[$i]['id'])
					. '">'.$products[$i]['name'].'</a></span>';

				$cart_contents_string .= '<span style="float: right;"><input class="count" id="pq-' . $products[$i]['id'] .
					'" value="' . $products[$i]['quantity'] .
					'" type="text">';

				if (basename($PHP_SELF) == FILENAME_AJAX_CHECKOUT) {
					$cart_contents_string .= '<button type="button" class="delete" rel="' . $products[$i]['id'] . '">&#10005;</button>';
				} else {
					$cart_contents_string .= '<button type="button" class="delete" rel="' . $products[$i]['id'] . '">&#10005;</button>';
				}
				
				$cart_contents_string .= tep_draw_hidden_field('products_id[]', $products[$i]['id'])
					. tep_draw_checkbox_field('cart_delete[]', $products[$i]['id'], false, "style=display:none;") . '</span>' ;

				if ((tep_session_is_registered('new_products_id_in_cart')) && ($new_products_id_in_cart == $products[$i]['id'])) {

					$cart_contents_string .= '</span>';
				}


				$cart_contents_string .='</li>';

			}
			$cart_contents_string .= '</ul>';

			$cart_contents_string .= '<div style="clear: both;"></div>';

			$cart_contents_string .= '<div class="boxcartTotal">' .
				'<span style="border-bottom: none;"><span id="boxcart-total" class="boxcart-total">' . $currencies->format($cart->show_total()) . '</span>' .
			'</span></div>' .
			'<div style="clear: both;"></div>';
		} else {

			$cart_contents_string .= '<ul id="boxcart-content">';
			$cart_contents_string .= '<li style="font-size:11px; float:right;">' . MODULE_BOXES_SHOPPING_CART_BOX_CART_EMPTY . '</li></ul>';

			$cart_contents_string .= '<div style="clear: both;"></div>';

			$cart_contents_string .= '<div class="boxcartTotal" id="boxcart-total-area">' .
				'<span style="border-bottom: none;"><span id="boxcart-total" class="boxcart-total">' . $currencies->format($cart->show_total()) . '</span></span>' .
			'</div>' .
			'<div style="clear: both;"></div>';
		}


		$data =  '<div class="ui-widget infoBoxContainer basket" id="span_cart_box">' . '<div class="ui-widget-content">' .
			'	 <div class="ui-widget-header infoBoxHeading"><a href="' . tep_href_link(FILENAME_SHOPPING_CART) . '">' . MODULE_BOXES_SHOPPING_CART_BOX_TITLE . '</a><div style="clear:both;"></div></div>' .
		'  <div class="head"><span class="name">' . MODULE_BOXES_SHOPPING_CART_PRODUCT_NAME . '</span><span class="count">'.MODULE_BOXES_SHOPPING_CART_QUANTITY.'</span></div>' .
		'  <div class="basket_list">' . $cart_contents_string . '';

		$data .= '<span id="boxcart-text-empty"
			style="display:none;">' . MODULE_BOXES_SHOPPING_CART_BOX_CART_EMPTY . '</span>' .
		'<span id="boxcart-text-remove"
			style="display:none;">' . IMAGE_BUTTON_UPDATE_CART . '</span>' .
		'<span id="boxcart-button-remove"
			style="display:none;">
			<button
			class="delete" type="button">' .
			'&#10005;' .
			'</button></span>' .
		'</div>';
		
			$data .= '</form>';
			
			$data .= tep_draw_hidden_field('symbol_left', $symbol_left, 'id="symbol_left"') .
							 tep_draw_hidden_field('symbol_right', $symbol_right, 'id="symbol_right"') .
							 tep_draw_hidden_field('decimal_places', $decimal_places, 'id="decimal_places"') .
							 tep_draw_hidden_field('thousands_point', $thousands_point, 'id="thousands_point"') .
							 tep_draw_hidden_field('decimal_point', $decimal_point, 'id="decimal_point"') .
							 tep_draw_hidden_field('IMAGE_BUTTON_DELETE', IMAGE_BUTTON_DELETE, 'id="IMAGE_BUTTON_DELETE"') .
							 tep_draw_hidden_field('IMAGE_BUTTON_CANCEL', IMAGE_BUTTON_CANCEL, 'id="IMAGE_BUTTON_CANCEL"') . '</div></div>';
		$oscTemplate->addBlock($data, $this->group);
	}

	function isEnabled() {
		return $this->enabled;
	}

	function check() {
		return defined('MODULE_BOXES_SHOPPING_CART_STATUS');
	}

	function install() {
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Shopping Cart Module', 'MODULE_BOXES_SHOPPING_CART_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Placement', 'MODULE_BOXES_SHOPPING_CART_CONTENT_PLACEMENT', 'Right Column', 'Should the module be loaded in the left or right column?', '6', '1', 'tep_cfg_select_option(array(\'Left Column\', \'Right Column\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_BOXES_SHOPPING_CART_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
	}

	function remove() {
		tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
	}

	function keys() {
		return array('MODULE_BOXES_SHOPPING_CART_STATUS', 'MODULE_BOXES_SHOPPING_CART_CONTENT_PLACEMENT', 'MODULE_BOXES_SHOPPING_CART_SORT_ORDER');
	}
}
?>
